/* DaVince's Tutorial 2
	For Newbies
	
This tutorial contains stuff how to draw text, images and objects onto the screen,
how to let the computer read what key you pressed,
how to create functions,
how to create and assign function parameters,
how to create and alter variables,
and how to let the computer continue ONLY when the right key was pressed.
If you wish to display any of these things on a map, just insert the RenderMap(); line before every FlipScreen.
*/

//Create variables.
var mywindow=LoadWindowStyle("white-blue.rws");	//Easier Windowstyle loading
var verdana=LoadFont("verdana10.rfn");				//Easy font loading
var blue=CreateColor(0, 0, 140);   		//Create a blue color in RGB values.
var gray=CreateColor(120,120,120);	//Colors can be stored in variables.
var red=CreateColor(180,0,0);
var white=CreateColor(255,255,255);

function game() {	//Always add this.
info();			//Start the info function on the bottom of the script.
text(10,5,"This is a line of text..");	//Call the homemade text function.
text_and_window(10,30,"This line of text has a window around it. The window checks the size of the text.");
FlipScreen();		//Make it draw on the screen.
GetKey();			//Wait for input.

  gradientback();		//Call the gradient background function below.
  text_and_window(10,25,"If this text size is changed the window gets resized too.");
  text_and_window(10,70,"The window width doesn't have to be changed because it's unneccesary.");
  text_and_window(10,130,"See?");
  text_and_window(10,160,"The background can be found in the gradientback function.");
  FlipScreen();
  GetKey();
  
    blue=CreateColor(0, 0, 140);   	//Change the blue to a darker blue value.
    ApplyColorMask(gray);             //Changing the background colour must be done BEFORE everything else drawn.
    text_colour(10,20,blue,"This text has been coloured dark blue and the background has been colored gray.");
    text_colour(10,80,red,"This text is red.\nThe next keypress wil show a gradient box.");
    FlipScreen();
    GetKey();
    
	square(30,40,red,blue,gray,white);
	verdana.setColorMask(white);   //Reset the colour to white.
	text_and_window(10,150,"If you wish to display any of these things on a map, just insert the RenderMap(); line before or after every FlipScreen. ");
	FlipScreen();   //The FlipScreen is here so everything is drawn at one time. Don't put it in the other functions,
	GetKey();       //unless you want to draw one thing at a time! If you do that add GetKey to the functions too.
	
    pressctrl();	//Start the press control function.
}


function text(x,y,str) {
//A new function. The 3 parameters (x,y,str) are not valid yet, but we are gonna make it valid.
//To give an invalid parameter something useful, start a command and give its standard
//parameters the same name.
//(x,y,str) are used below, too, but in a valid command (drawText), so the three invalid parameters become valid.
//The invalid parameters now actually will give the x and y coordinates and the text to show.
//That way the program will always set the x position to 10.

verdana.drawText(x,y,str);   //A normal DrawText will draw one-line texts and will go beyond the screen border if too big.
}

function text_and_window(x,y,str) {
//The x and y parameters are used for the window AND text position,
//but the str parameter will tell what text to draw. This is the power of new function params:
//You can give params for colours, sizes, positions or objects in the same function,
//as long as all params are told what to do!

var width=300
var height=verdana.getStringHeight(str, width);  //Look at how high the string is to dtermine the TextBox height.
mywindow.drawWindow(x,y,width,height);  //Draw a window.
verdana.drawTextBox(x,y,width,height,0,str);   //A DrawTextBox will keep the text in a box for word-wrapping.
}


function text_colour(x,y,colour,str) {	//colour is user definable if combined with line 67.
var width=300
var height=verdana.getStringHeight(str, width);
verdana.setColorMask(colour);   		//If you define "colour", the user will be able to define.
verdana.drawTextBox(x,y,width,height,0,str);
}


function square(x,y,c1,c2,c3,c4) {	//The width and height are always the same here, to make it differ from the original
GradientRectangle(x, y, 260,100,c1,c2,c3,c4);  //Colours 1 to 4 are the start colour of every corner.
}


function pressctrl() {
text_and_window(10,30,"You can only continue this text by pressing ctrl.");
FlipScreen();
var key=GetKey()	//Read the key you press if it isn't ctrl AND wait for a keypress.
if(IsKeyPressed(KEY_CTRL)) {		//What if the control key is pressed? Execute below!
text_and_window(10,30,"Yes. Good!\nThat was the tutorial!");  	 //Say this and go to the commands after else.
}
else {					//What if any other key than control is pressed?
text_and_window(10,200,"Press ctrl, not "+ GetKeyString(key,false)+"!");	//Say this+the key you pressed (and !).
pressctrl();				//Restart this function again (=try again)!
}

/*	Those commands are executed under both above conditions,
	because they're outside both conditions.  */
FlipScreen();
GetKey();	
Exit();	//If you don't exit immediately after the final example, you'll see a black screen!
}

function info() {
gradientback();		//Call the gradient background function below.
text_and_window(10,20,"This tutorial was made by DaVince in 2004. For other tutorials, go to http://DaVince.sitesled.com/ . For comments email VincentBeers@yahoo.com. This tutorial is made for beginners, mainly because I made those tutorials to learn stuff myself.\n\tEnjoy.");
text_and_window(10,180,"I can always use help or tutorials, too, to improve my own skills.");
FlipScreen();
GetKey();
}

function gradientback() {
var black=CreateColor(0,0,0);		//Create a black colour (in RGB). A fourth parameter invokes transparency.
blue=CreateColor(0,0,255);	//Since blue already existed, we can leave the 'var' away. Variable blue gets changed.
GradientRectangle(0,0,320,240,blue,black,blue,black);	//Draw a gradient rectangle.
//GradientRectangle(StartX, StartY, EndX, EndY, 4_Corner_colours.);
// 4_corner_colours in order: Left top, Right top, right down and left down.
}